Bug 182726 - Possible hang when ptracing and using hugepages
Possible hang when ptracing and using hugepages
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Bastien Nocera
Brian Brock
:
Depends On:
Blocks: 181409 185483
  Show dependency treegraph
 
Reported: 2006-02-24 05:43 EST by Bastien Nocera
Modified: 2010-10-22 00:16 EDT (History)
1 user (show)

See Also:
Fixed In Version: RHSA-2006-0575
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-08-10 18:27:09 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
ptrace-hang.patch (548 bytes, patch)
2006-02-24 05:43 EST, Bastien Nocera
no flags Details | Diff

  None (edit)
Description Bastien Nocera 2006-02-24 05:43:20 EST
kernel-2.6.9-27.EL

This hang might occur when ptracing a process and hugepages are in use:
PID: 3892   TASK: e000004093ab0000  CPU: 1   COMMAND: "test"
#0 [BSP:e000004093ab1268] start_disk_dump at a00000020036dca0
#1 [BSP:e000004093ab1248] try_crashdump at a0000001000ab2d0
#2 [BSP:e000004093ab1218] start_dump_osinit at a00000010004c820
#3 [BSP:e000004093ab11e8] unw_init_running at a00000010000faf0
#4 [BSP:e000004093ab1078] ia64_init_handler at a00000010004f220
 EFRAME: e0000000047cf7b0
     B0: a000000100122a90      CR_IIP: a000000100008ca0
CR_IPSR: 0000101008126010      CR_IFS: 8000000000000000
 AR_PFS: 0000000000000081      AR_RSC: 0000000000000003
AR_UNAT: 0000000000000000     AR_RNAT: 0000000000000000
 AR_CCV: e0000040920dee80     AR_FPSR: 0009804c0270033f
 LOADRS: 0000000000000000 AR_BSPSTORE: 0000000000000000
     B6: a00000010057d1e0          B7: a000000100012750
     PR: 0000000005565959          R1: a00000010099d2f0
     R2: 000000000000038a          R3: a00000010099d2f0
     R8: a00000010064f248          R9: ffffffffffffffff
    R10: 0000000000000000         R11: 00000000055616d9
    R12: e000004093ab79c0         R13: e000004093ab0000
    R14: 0000000000000000         R15: 0000000000008001
    R16: 0000000000008001         R17: e0000040b0004010
    R18: e0000040b0004011         R19: e0000040b0004000
    R20: 000000000102c001         R21: 0000000007134007
    R22: 00000000389a0038         R23: a0007fffffba0038
    R24: a0007fffc7200000         R25: e000004093ab79d0
    R26: 0000000000000007         R27: 0000000000000000
    R28: 0000000000000000         R29: 0000000000000000
    R30: 0000000000000001         R31: a00000010064f260
     F6: 000000000000000000000     F7: 1003e0000000007134007
     F8: 1003e000000000102c001     F9: 1003e0000000007134007
    F10: 1003e0000000000000284    F11: 1003e6db6db6db6db6db7
#5 [BSP:e000004093ab1078] ia64_spinlock_contention at a000000100008ca0
#6 [BSP:e000004093ab1070] _spin_lock at a00000010057d1e0
#7 [BSP:e000004093ab1038] __set_page_dirty_buffers at a000000100122a90
#8 [BSP:e000004093ab1018] set_page_dirty at a0000001000dbe60
#9 [BSP:e000004093ab0fe8] set_page_dirty_lock at a0000001000dbf10
#10 [BSP:e000004093ab0f48] access_process_vm at a000000100088da0
#11 [BSP:e000004093ab0ee8] ia64_poke at a000000100031110
#12 [BSP:e000004093ab0e30] sys_ptrace at a000000100034500
#13 [BSP:e000004093ab0e30] ia64_ret_from_syscall at a00000010000f320
 EFRAME: e000004093ab7e40
     B0: 4000000000000e70      CR_IIP: a000000000010640
CR_IPSR: 00001213081a6018      CR_IFS: 0000000000000000
 AR_PFS: c000000000000004      AR_RSC: 000000000000000f
AR_UNAT: 0000000000000000     AR_RNAT: 0000000000000000
 AR_CCV: 0000000000000000     AR_FPSR: 0009804c8a70033f
 LOADRS: 0000000000200000 AR_BSPSTORE: 60000fff7fffc050
     B6: 20000000001f0220          B7: 20000000000f53b0
     PR: 000000000555a261          R1: 2000000000264238

Upstream commit, patch attached:
http://www.kernel.org/git/?p=linux/kernel/git/gregkh/linux-2.6.15.y.git;a=commitdiff_plain;h=5bd0190bf3d7e53043a048e809ffa29d41b9d6ac;hp=df69a60dc6afc2936d79054d30b481c1fd9720e5
Comment 1 Bastien Nocera 2006-02-24 05:43:20 EST
Created attachment 125171 [details]
ptrace-hang.patch
Comment 4 Bob Johnson 2006-04-11 12:01:01 EDT
This issue is on Red Hat Engineering's list of planned work items 
for the upcoming Red Hat Enterprise Linux 4.4 release.  Engineering 
resources have been assigned and barring unforeseen circumstances, Red 
Hat intends to include this item in the 4.4 release.
Comment 5 Jason Baron 2006-04-20 23:16:30 EDT
committed in stream U4 build 34.21. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/
Comment 6 David Lawrence 2006-04-27 13:24:00 EDT
Mistakenly added IBM group. Removed/
Comment 8 Mike Gahagan 2006-06-22 18:12:47 EDT
already verified fixed by IBM and myself on ppc.. case is in RHTS unfortunately
at this time it only builds on ppc. Should I just go with that or should we have
more arch test coverage here?
Comment 10 Mike Gahagan 2006-06-26 16:51:38 EDT
ran ptrace_write_hugepage on x86_64 (-39smp) using a new version of libhugetlbfs
slated for inclusion in FC extras... test seems to pass, but I couldn't get a
crash or failure on an older kernel (-22) so I'm not sure how far I trust it.
Comment 13 Red Hat Bugzilla 2006-08-10 18:27:11 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0575.html

Note You need to log in before you can comment on or make changes to this bug.